#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <arpa/inet.h>

#include "timestamp.h"

void ts_read(struct timestamp *dest, void* src) {
  uint32_t *buf = src;
  dest->sec = ntohl(buf[0]);
  dest->fra = ntohl(buf[1]);
}

void ts_write(struct timestamp *src, void* dest) {
  uint32_t *buf = dest;
  buf[0] = htonl(src->sec);
  buf[1] = htonl(src->fra);
}

int ts_current(struct timestamp *ts) {
  int ret;
  struct timeval tv;
  ret = gettimeofday(&tv, NULL);
  // 0x83aa7e80L = nombre seconds de 1900 à 1970
  ts->sec = tv.tv_sec + 0x83aa7e80L;
  ts->fra = tv.tv_usec * 4295L;	     // 4295L = approximation de 10^-6*2^32
  return ret;
}

char* tstop(struct timestamp* ts) {
  static char dest[4][50];
  static int i = 0;
  struct timeval tv = {
    .tv_sec = ts->sec - 0x83aa7e80L, // 0x83aa7e80L = nombre seconds de 1900 à 1970
    .tv_usec = ts->fra / 4295L	     // 4295L = approximation de 10^-6*2^32
  };
  i = (i+1) % 4;
  if (ts->sec == 0)
    sprintf(dest[i], "[--]");
  else
    sprintf(dest[i], "[%.24s %lu]", ctime(&tv.tv_sec), tv.tv_usec);
  return dest[i];
}
