#ifndef __TIMESTAMP_H__
#define __TIMESTAMP_H__

#include <stdint.h>
#include <sys/time.h>

// Représentation d'un timestamp selon le protocole SNTP :

struct timestamp {
  uint32_t sec;
  uint32_t fra;
};

// Initialise ts avec l'heure courante.
// Renvoie -1, en cas d'erreur.
int ts_current(struct timestamp *ts);

// Renvoie ts sous la forme d'une chaîne de caractère affichable
char* tstop(struct timestamp* ts);

// Lecture/Écriture dans un buffer
void ts_read(struct timestamp *dest, void* src);
void ts_write(struct timestamp *src, void* dest);

#endif /* __TIMESTAMP_H__ */
